//
// cpuid_tbl.cpp - Define different x86 CPUs
//

#include "my_types.h"
#include "cpuid_x86.h"


CPUID_DEFS cpuid_tbl[] = {
	{0x000,0,1,"[GenuineIntel]","Intel","Intel Corp.",""},	// 0,0,0,0 = New Vendor
	{0x40F,-1,-1,"486 DX-25/33","486","",""},
	{0x41F,-1,-1,"486 DX-50","486","",""},
	{0x42F,-1,-1,"486 SX","486","",""},
	{0x43F,-1,-1,"486 DX2","486","",""},
	{0x44F,-1,-1,"486 SL","486","",""},
	{0x45F,-1,-1,"486 SX2","486","",""},
	{0x47F,-1,-1,"486 DX2E","486","",""},
	{0x48F,-1,-1,"486 DX4","486","P24C",""},
	{0x49F,-1,-1,"486 DX4","486","P24CT",""},
	{0x50F,-1,-1,"Pentium","P1","66a",""},
	{0x51F,-1,-1,"Pentium","P1","66a",""},
	{0x52F,-1,-1,"Pentium","P1","P54C",""},
	{0x53F,-1,-1,"Pentium","P1","P24T",""},
	{0x54F,-1,-1,"Pentium-MMX","P1m","P55C",""},
	{0x57F,-1,-1,"Pentium-I-M","P1m","",""},
	{0x58F,-1,-1,"Pentium-MMX-M","P1m","Tillamook",""},
	{0x60F,-1,-1,"Pentium-Pro","P1m","A-step",""},
	{0x61F,-1,-1,"Pentium-Pro","P1m","B-step",""},
// Pentium II
	{0x63F,-1,-1,"Pentium-II","P2","Klamath",""},
	{0x65F, 0xFF, 128,"Celeron","P2c","Covington",""},
	{0x65F, 0xFF, 512,"Pentium-II","P2","Deschutes",""},
	{0x65F,0x2020, 512,"Xeon DP","P2x","Drake",""},
	{0x66F,-1, 128,"Celeron","P2","Mendocino",""},
	{0x66F,-1, 256,"Pentium-II","P2","Dixon",""},
// Pentium III	
	{0x67F,-1, 512,"Pentium-III","P3","Katmai",""},
	{0x67F,-1,1024,"Xeon DP","P3x","Tanner",""},

	{0x68F, 0xFF, 128,"Celeron P3","P3","Coppermine",""},
	{0x68F, 0x2002, 256,"Pentium-III","P3","Coppermine",""},
	{0x68F, 0x2020, -1,"Xeon MP","P3x","Cascades",""},	// brand is less than current value (example 0x04)
// Pentium M
	{0x69F, -1, 512,"Celeron M","PM","Banias",""},
	{0x69F, -1,1024,"Pentium M","PM","Banias",""},
// Pentium III(again)
	{0x6AF, -1, -1,"Xeon","P3x","Cascades",""},
	{0x6BF,-1,256,"Celeron","P3","Tualatin",""},
	{0x6BF,-1,512,"Pentium-III","P3","Tualatin",""} ,
// Pentium M (again)
	{0x6DF,-1,1024,"Celeron M","PM","Dothan",""},
	{0x6DF,-1,4096,"Pentium M","PM","Dothan",""},

	{0x6EF,-1,-1,"Core Duo","PM","Yonah",""},

	{0x6FF,0x0220,2048,"Core 2 Duo","C2D","Conroe 2M","E6xxx"},
	{0x6FF,0x0220,4096,"Core 2 Duo","C2D","Conroe","E6xxx"},
	{0x6FF,0x0220,8192,"Core 2 Duo","C2D","Kentsfield","E6xxx"},
	{0x6FF,0x8220,4096,"Xeon 51xx","C2Dx","Woodcrest","51xx"}, // up 2 8 cpus, 2 cores, 32K L1

	{0x70F, 0x000,-1,"Itanium","IA64","Merced",""},
	{0x70F, 0x100,-1,"Itanium-II","IA64-2","McKinley",""},
	{0x71F, 0x100,-1,"Itanium-II","IA64-2","Madison",""},
	{0x72F, 0x100,-1,"Itanium-II","IA64-2","Madison 9M",""},
	{0x7FF, -1,-1,"Itanium-II Plus","IA64+","Unknown",""},

	{0xF12,  0xFF,-1,"Pentium-IV","P4","Willamette",""},
	{0xF12,0x20FF,-1,"Xeon DP","P4","Foster",""},
	{0xF12,0x80FF,-1,"Xeon MP","P4","Foster",""},
	{0xF1F,-1,-1,"Pentium-IV","P4","Willamette",""},

	{0xF22, -1,256+1024,"Xeon MP","P4","Foster",""},
	{0xF22, -1,512+1024,"Xeon MP","P4","Gallatin",""},

	{0xF24,  0xFF,128,"Celeron","P4c","Northwood","(mobile)"},
	{0xF24,  0xFF,512,"Pentium-IV","P4","Northwood",""},
	{0xF24,0x20FF,512,"Xeon DP","P4","Prestonia",""},

	{0xF25,0x09,512+2048,"Pentium-IV EE","P4","Gallatin",""},
	{0xF25,0x20FF,512+1024,"Xeon DP","P4","Prestonia B" ,""},
	{0xF25,0x80FF,512+2048,"Xeon MP","P4","Gallatin",""},	// There is one Prestonia with 2M L3

	{0xF26,0x0210,4096,"Pentium D","PD","Presler","xxx"},
	{0xF26,0x80FF,512+4096,"Xeon MP","P4","Gallatin",""},

	{0xF2F,  0x0A,128,"Celeron","P4c","Northwood","(mobile)"},
	{0xF2F,  0x0A,512,"Pentium-IV","P4","Northwood",""},
	{0xF2F,  0x0C,512,"Xeon DP","P4","Prestonia",""},		// 0B & 0C = Xeon (sandpile.org)
	{0xF2F,  0xFF,512,"Pentium-IV","P4","Northwood",""},	//Brand: 0E
	{0xF2F,0x0210,4096,"Pentium D","PD","Presler","xxx"},
	{0xF2F,0x200C,-1,"Xeon DP","P4","Prestonia",""},		// 0B & 0C = Xeon
	{0xF2F,0x8410,-1,"Xeon 70xx","PDx","Paxville","70xx"},

	{0xF3F,  0xFF, 256,"Celeron","P4c","Prescott",""},
	{0xF3F,  0xFF, 2048,"Pentium-IV","P4","Prescott",""},
	{0xF3F,0x20FF, 1024,"Xeon DP","P4","Nocona",""},

	{0xF41,  0xFF, 256,"Celeron","P4","Prescott",""},
	{0xF41,  0xFF,1024,"Pentium-IV","P4","Prescott",""},
//	{0xF3F,0x20FF,1024,"Xeon DP","P4","Nocona",""},
	{0xF41,0x80FF,1024,"Xeon MP","P4","Cranford","MP"},
	{0xF41,0x80FF,1024+8192,"Xeon MP","P4","Potomac","MP"},

	{0xF4F,  0xFF, 256,"Celeron","PD","Prescott",""},
	{0xF4F,  0xFF,2048,"Pentium-IV","P4","Prescott",""},
	{0xF4F,0x0210,2048,"Pentium D","PD","Smithfield",""},
	{0xF4F,0x20FF,1024,"Xeon DP","P4","Nocona",""},
	{0xF4F,0x20FF,2048,"Xeon DP","P4","Irwindale",""},
	{0xF4F,0x8410,4096,"Xeon MP 70xx","PDx","Paxville","70xx"},

	{0xF6F,  0xFF,-1,"Pentium-IV","P4","Cedar Mill",""},
	{0xF6F,0x0210,-1,"Pentium D","PD","Presler",""},
	{0xF6F,0x2410,-1,"Xeon DP 50xx","PDx","Dempsey","50xx"},
	{0xF6F,0x8410,-1,"Xeon MP 71xx ","PDx","Tulsa","71xx"},

	{0xFFF,-1,-1, "Pentium-IV Plus","P4+","",""},
//
// AMD
//
	{0x000,0,2,"[AMD ISBETTER]","AMD","Advanced Micro Devices",""},
	{0x000,0,2,"[AuthenticAMD]","AMD","Advanced Micro Devices",""},
	{0x43F,-1,-1,"486 DX2","Am486","",""},
	{0x47F,-1,-1,"486 DX2","Am486","",""},
	{0x48F,-1,-1,"486 DX4","Am486","",""},
	{0x49F,-1,-1,"486 DX4","Am486","",""},
	{0x4EF,-1,-1,"Am5x86","5x86","",""},
	{0x4FF,-1,-1,"Am5x86","5x86","SSA5",""},
	{0x50F,-1,-1,"PR75","K5","",""},
	{0x51F,-1,-1,"PR120","K5","Godot",""},
	{0x52F,-1,-1,"PR166","K5","Godot",""},
	{0x53F,-1,-1,"PR200","K5","Godot",""},
	{0x56F,-1,-1,"K6","K6","","Little Foot"},
	{0x57F,-1,-1,"K6","K6","Little Foot",""},
	{0x58F,-1,-1,"K6-II 3D","K6!","Chompers",""},
	{0x59F,-1,-1,"K6-III 3D","K6!","Sharptooth",""},
// AMD K7
	{0x60F,-1,-1,"Athlon","K7","Argon",""},
	{0x61F,-1,-1,"Athlon","K7","Argon",""},
	{0x62F,-1,-1,"Athlon","K7","Pluto",""},
	{0x63F,-1,-1,"Duron","K7","Spitfire",""},
	{0x64F,-1,-1,"Athlon","K7","Thunderbird",""},
	{0x65F,-1,-1,"Athlon","K7","",""},
		//With model >=6, If the L2 cache size reported is less than 256, then the processor is an AMD Duron family processor
		//MP if multiprocessor bit is set
	{0x66F,-1,128,"Duron XP","K7x","Palomino",""},
	{0x66F,-1, -1,"Athlon XP","K7x","Palomino",""},
	{0x67F,-1,64,"Duron XP","K7x","Morgan",""},
	{0x67F,-1, -1,"Athlon XP","K7x","Morgan",""},
	{0x68F,-1,128,"Duron XP","K7x","Applebred",""},
	{0x68F,-1, -1,"Athlon XP","K7x","Thoroughbred",""},
	{0x69F,-1,128,"Duron XP","K7x","Thoroughbred",""},
	{0x69F,-1, -1,"Athlon XP","K7x","Thoroughbred",""},
	{0x6AF,-1,256,"Duron XP","K7x","Thorton",""},
	{0x6AF,-1, -1,"Athlon XP","K7x","Barton",""},

	{0x6FF,-1,16,"Athlon XP plus","K7+","Unknown",""},

	{0x78F,-1,-1,"Athlon XP","K7","Barton","XX00+"},
	{0x7FF,-1,-1,"Athlon XP","K7","xxx",""},


//
// AMD K8
//
//	{0xE99,11,  0, 0x05,-1,"Athlon 64 X2","K8","Manchester","XX00+"},


	{0xFFF, 0x02FF,-1,"Turion 64"	,"K8","xxx","Mobile TL-XX"},
	{0xFFF, 0x0404,-1,"Athlon 64"	,"K8","ClawHammer","XX00+"},
	{0xFFF, 0x040C,-1,"Athlon 64"	,"K8","Newcastle","XX00+"},
	{0xFFF, 0x041F,-1,"Athlon 64"	,"K8","Winchester","XX00+"},
	{0xFFF, 0x0427,-1,"Athlon 64"	,"K8","San Diego","XX00+"},
	{0xFFF, 0x042F,-1,"Athlon 64"	,"K8","Venice","XX00+"},
	{0xFFF, 0x0437,-1,"Athlon 64"	,"K8","San Diego","XX00+"},
	{0xFFF, 0x043F,-1,"Athlon 64"	,"K8","Manchester","XX00+"},
	{0xFFF, 0x04FF,-1,"Athlon 64"	,"K8","xxx","XX00+"},
	{0xFFF, 0x0523,-1,"Athlon 64 X2","K8","Toledo","XX00+"},
	{0xFFF, 0x052B,-1,"Athlon 64 X2","K8","Manchester","XX00+"},
	{0xFFF, 0x0543,-1,"Athlon 64 X2","K8","Windsor","XX00+"},
	{0xFFF, 0x054B,-1,"Athlon 64 X2","K8","Brisbane","XX00+"},
	{0xFFF, 0x05FF,-1,"Athlon 64 X2","K8","xxx","XX00+"},
	{0xFFF, 0x060C,-1,"Sempron"		,"K8","Paris","TT00+"},
	{0xFFF, 0x06FF,-1,"Sempron"		,"K8","xxx","TT00+"},
	{0xFFF, 0x0800,-1,"Athlon 64"	,"K8","ClawHammer","XX00+ mobile"},
	{0xFFF, 0x080C,-1,"Athlon 64"	,"K8","Odessa","XX00+ mobile"},
	{0xFFF, 0x081C,-1,"Athlon 64"	,"K8","Oakville","XX00+ mobile"},
	{0xFFF, 0x0824,-1,"Athlon 64"	,"K8","Newark","XX00+ mobile"},
	{0xFFF, 0x0840,-1,"Athlon 64"	,"K8","ClawHammer","XX00+ mobile"},
	{0xFFF, 0x0910,-1,"Athlon 64"	,"K8","Oakville","XX00+ mobile, low power"},
	{0xFFF, 0x09FF,-1,"Athlon 64"	,"K8","xxx","XX00+ mobile, low power"},
	{0xFFF, 0x0A24,-1,"Turion 64"	,"K8","Lancaster","MT-XX"},
	{0xFFF, 0x0AFF,-1,"Turion 64"	,"K8","xxx","ML-XX"},
	{0xFFF, 0x0B24,-1,"Turion 64"	,"K8","Lancaster","MT-XX"},
	{0xFFF, 0x0BFF,-1,"Turion 64"	,"K8","xxx","MT-XX"},
	{0xFFF, 0x0C00,-1,"Opteron 1"	,"K8","Sledgehammer","YY"},
	{0xFFF, 0x0C27,-1,"Opteron 1"	,"K8","Venus","YY"},
	{0xFFF, 0x0CFF,-1,"Opteron 1"	,"K8","xxx","YY"},
	{0xFFF, 0x0DFF,-1,"Opteron 1"	,"K8","Sledgehammer","YY"},
	{0xFFF, 0x0EFF,-1,"Opteron 1"	,"K8","Sledgehammer","YY HE"},
	{0xFFF, 0x0FFF,-1,"Opteron 1"	,"K8","Sledgehammer","YY EE"},
	{0xFFF, 0x10FF,-1,"Opteron 2"	,"K8","Sledgehammer","YY"},
	{0xFFF, 0x1127,-1,"Opteron 2"	,"K8","Troy","YY"},
	{0xFFF, 0x11FF,-1,"Opteron 2"	,"K8","xxx","YY"},
	{0xFFF, 0x12FF,-1,"Opteron 2"	,"K8","Sledgehammer","YY HE"},
	{0xFFF, 0x13FF,-1,"Opteron 2"	,"K8","Sledgehammer","YY EE"},
	{0xFFF, 0x1425,-1,"Opteron 8"	,"K8","Athens","YY"},
	{0xFFF, 0x14FF,-1,"Opteron 8"	,"K8","Sledgehammer","YY"},
	{0xFFF, 0x1500,-1,"Opteron 8"	,"K8","Sledgehammer","YY"},
	{0xFFF, 0x1525,-1,"Opteron 8"	,"K8","Athens","YY"},
	{0xFFF, 0x15FF,-1,"Opteron 8"	,"K8","xxx","YY"},
	{0xFFF, 0x16FF,-1,"Opteron 8"	,"K8","Sledgehammer","YY HE"},
	{0xFFF, 0x17FF,-1,"Opteron 8"	,"K8","Sledgehammer","YY EE"},
	{0xFFF, 0x18FF,-1,"Athlon 64"	,"K8","xxx","EE00+"},
	{0xFFF, 0x1D0C,-1,"Athlon XP-M"	,"K8","Dublin","XX00+ mobile"},
	{0xFFF, 0x1DFF,-1,"Athlon XP-M"	,"K8","xxx","XX00+ mobile"},
	{0xFFF, 0x1EFF,-1,"Athlon XP-M"	,"K8","Dublin","XX00+ mobile, low power"},
	{0xFFF, 0x20FF,-1,"Athlon XP"	,"K8","xxx","XX00+"},
	{0xFFF, 0x210C,-1,"Sempron"		,"K8","Dublin","TT00+ mobile, 32-bit"},
	{0xFFF, 0x211C,-1,"Sempron"		,"K8","Georgetown","TT00+ mobile, 32-bit"},
	{0xFFF, 0x21FF,-1,"Sempron"		,"K8","xxx","TT00+ mobile, 32-bit"},
	{0xFFF, 0x220C,-1,"Sempron"		,"K8","Paris","TT00+, 32-bit"},
	{0xFFF, 0x222F,-1,"Sempron"		,"K8","Palermo","TT00+, 32-bit"},
	{0xFFF, 0x224F,-1,"Sempron"		,"K8","Manila","TT00+, 32-bit"},
	{0xFFF, 0x22FF,-1,"Sempron"		,"K8","xxx","TT00+, 32-bit"},
	{0xFFF, 0x23FF,-1,"Sempron"		,"K8","xxx","TT00+ mobile, 32-bit, low power"},
	{0xFFF, 0x231C,-1,"Sempron"		,"K8","Sonora","TT00+ mobile, 32-bit, low power"},
	{0xFFF, 0x232C,-1,"Sempron"		,"K8","Albany","TT00+ mobile, 32-bit, low power"},
	{0xFFF, 0x23FF,-1,"Sempron"		,"K8","xxx","TT00+ mobile, 32-bit, low power"},
	{0xFFF, 0x240F,-1,"Athlon 64 FX","K8","Sledgehammer","-ZZ"},
	{0xFFF, 0x2405,-1,"Athlon 64 FX","K8","ClawHammer","-ZZ"},
	{0xFFF, 0x2423,-1,"Athlon 64 FX","K8","Toledo","-ZZ"},
	{0xFFF, 0x2427,-1,"Athlon 64 FX","K8","San Diego","-ZZ"},
	{0xFFF, 0x2443,-1,"Athlon 64 DC FX","K8","Windsor","-ZZ"},
	{0xFFF, 0x24FF,-1,"Athlon 64 FX","K8","xxx","-ZZ"},
	{0xFFF, 0x261C,-1,"Sempron"		,"K8","Palermo","TT00+, 64-bit"},	//C2
	{0xFFF, 0x264F,-1,"Sempron"		,"K8","Manila","TT00+, 64-bit"},	//C2
	{0xFFF, 0x26FF,-1,"Sempron"		,"K8","xxx","TT00+, 64-bit"},
	{0xFFF, 0x29FF,-1,"Opteron DC 1","K8","xxx","RR SE"},
	{0xFFF, 0x2AFF,-1,"Opteron DC 2","K8","xxx","RR SE"},
	{0xFFF, 0x2BFF,-1,"Opteron DC 8","K8","xxx","RR SE"},
	{0xFFF, 0x2C23,-1,"Opteron DC 1","K8","Denmark",""},
	{0xFFF, 0x2CFF,-1,"Opteron DC 1","K8","xxx",""},
	{0xFFF, 0x2DFF,-1,"Opteron DC 1","K8","xxx",""},
	{0xFFF, 0x2EFF,-1,"Opteron DC 1","K8","xxx","RR HE"},
	{0xFFF, 0x2FFF,-1,"Opteron DC 1","K8","xxx","RR HE"},
	{0xFFF, 0x3021,-1,"Opteron DC 2","K8","Italy",""},
	{0xFFF, 0x30FF,-1,"Opteron DC 2","K8","xxx",""},
	{0xFFF, 0x31FF,-1,"Opteron DC 2","K8","xxx",""},
	{0xFFF, 0x32FF,-1,"Opteron DC 2","K8","xxx","RR HE"},
	{0xFFF, 0x33FF,-1,"Opteron DC 2","K8","xxx","RR HE"},
	{0xFFF, 0x34FF,-1,"Opteron DC 8","K8","xxx",""},
	{0xFFF, 0x35FF,-1,"Opteron DC 8","K8","xxx",""},
	{0xFFF, 0x36FF,-1,"Opteron DC 8","K8","xxx","RR HE"},
	{0xFFF, 0x37FF,-1,"Opteron DC 8","K8","xxx","RR HE"},
	{0xFFF, 0x38FF,-1,"Opteron DC 1","K8","xxx",""},
	{0xFFF, 0x39FF,-1,"Opteron DC 2","K8","xxx",""},
	{0xFFF, 0x3AFF,-1,"Opteron DC 8","K8","xxx",""},

	{0x0FFF,-2,-1,"Athlon 64+","K8+","Unknown",""},
//
// Cyrix
//
	{0x000,0,3,"[CyrixInstead]","Cyrix","Cyrix Corp. / VIA Inc.",""},
	{0x44F,-1,-1,"MediaGX","MedGx","",""},
		// CPU feature flags. The 6x86L supports the "compare and exchange 8-byte
	{0x53F,-1,-1,"6x86/6x86L","6x86L","",""},
	{0x54F,-1,-1,"MediaGX","GxMmx","MMX enhanced",""},
	{0x60F,-1,-1,"6x86MX","6x86MX","MII",""},
	{0x65F,-1,-1,"VIA-Cyrix","M2","M2",""},
	{0x66F,-1,-1,"Cyrix-III","C5A","Samuel",""},
	{0x677,-1,-1,"WinChip-C3","C5C","Samuel-2",""},
	{0x678,-1,-1,"WinChip-C3","C5C","Ezra",""},
	{0x689,-1,-1,"WinChip-C3","C5N","Ezra-T",""},
	{0x697,-1,-1,"WinChip-C3","C5x","Nehemiah",""},
	{0x698,-1,-1,"WinChip-C3-M","C5x","Antaur",""},
	
	{0x00F,0,4,"[UMC UMC UMC ]","UMC","United Microelectronics Corp.",""},
	{0x2FF,-1,-1,"U5S","U5S","",""},
	{0x41F,-1,-1,"U5D","U5D","",""},
	
	{0x000,0,5,"[NexGenDriven]","Nexgen","NexGen Inc.",""},
	{0x50F,-1,-1,"Nx586","Nx586","",""},
	
	{0x000,0,6,"[RiseRiseRise]","Rise","Rise",""},
	{0x50F,-1,-1,"mP6","mP6","",""},
	
	{0x000,0,7,"[SiS SiS SiS ]","","",""},
	{0x50F,-1,-1,"55x","55x","",""},

	{0x000,0,8,"[TransmetaCPU]","TMT","Transmeta",""},
	{0x000,0,8,"[GenuineTMx86]","TMT","Transmeta",""},
	{0x54F,-1,-1,"Crusoe","Crusoe","TM3x00",""},

	{0x000,0,8,"[CentaurHauls]","IDT","IDT or VIA",""},
	{0x54F,-1,-1,"C6","C6","",""},
	{0x8FF,-1,-1,"C2","C2","",""},
	{0x9FF,-1,-1,"C3","C3","",""},


	{0x000,0,9,"[Geode by NSC]","NSC","National Semiconductor ",""},
	{0x54F,-1,-1,"GX1","GX1","GXLV",""},
	{0x55F,-1,-1,"GX2","GX2","",""},

	{0x000,-2,-1,"","","",""},	// Terminator
	};

AMD_PERFTBL perfTbl[] = {
	{256, 950,  1100},
	{256, 1000, 1200},
	{256, 1100, 1300},
	{256, 1200, 1400},
	{256, 1300, 1500},
	{256, 1333, 1500},
	{256, 1400, 1600},
	{256, 1467, 1700},
	{256, 1500, 1800},
	{256, 1533, 1800},
	{256, 1600, 1900},
	{256, 1667, 2000},
	{256, 1733, 2100},
	{256, 1800, 2200},
	{256, 2000, 2400},
	{256, 2083, 2600},
	{256, 2133, 2600},
	{256, 2167, 2700},
	{256, 2250, 2800},
	{512, 1300, 1700},
	{512, 1400, 1800},
	{512, 1467, 1900},
	{512, 1533, 2000},
	{512, 1600, 2100},
	{512, 1667, 2200},
	{512, 1800, 2400},
	{512, 1833, 2500},
	{512, 1867, 2500},
	{512, 1917, 2600},
	{512, 2000, 2600},
	{512, 2083, 2800},
	{512, 2100, 3000},
	{512, 2133, 2800},
	{512, 2167, 3000},
	{512, 2200, 3200}
	};

// Earlier Intel & other tokenized cache info values

//05 B0 B1 01 - 00 56 57 F0 00 00 00 00 2C B4 30 49
_cacheCodes cacheCodes[] = {
	{0x06,32,  8,   0,   0,   0},
	{0x08,32, 16,   0,   0,   0},
	{0x0A,32,  0,   8,   0,   0},
	{0x0C,32,  0,  16,   0,   0},
	{0x15,32, 16,   0,   0,   0},
	{0x1A,64,  0,   0,  96,   0},
	{0x1F,32,  0,  16,   0,   0},
	{0x22,64,  0,   0,   0, 512},
	{0x23,64,  0,   0,   0,1024},
	{0x25,64,  0,   0,   0,2048},
	{0x29,64,  0,   0,   0,4096},
	{0x2c,64,  0,  32,   0,   0},
	{0x30,64, 32,   0,   0,   0},
	{0x39,64,  0,   0, 128,   0},
	{0x3A,64,  0,   0, 192,   0},
	{0x3B,64,  0,   0, 128,   0},
	{0x3C,64,  0,   0, 256,   0},
	{0x3D,64,  0,   0, 384,   0},
	{0x3E,64,  0,   0, 512,   0},
	{0x41,32,  0,   0, 128,   0},
	{0x42,32,  0,   0, 256,   0},
	{0x43,32,  0,   0, 512,   0},
	{0x44,32,  0,   0,1024,   0},
	{0x45,32,  0,   0,2048,   0},
	{0x46,64,  0,   0,   0,4096},
	{0x47,64,  0,   0,   0,8192},
	{0x49,64,  0,   0,   0,4096},
	{0x4A,64,  0,   0,   0,6144},
	{0x4B,64,  0,   0,   0,8192},
	{0x4C,64,  0,   0,   0,12288},
	{0x4D,64,  0,   0,   0,16384},
	{0x60,64,  0,  16,   0,   0},
	{0x66,64,  0,   8,   0,   0},
	{0x67,64,  0,  16,   0,   0},
	{0x68,64,  0,  32,   0,   0},
	{0x6F,32,  8,   0,   0,   0},
	{0x70,0 , 12,   0,   0,   0},
	{0x71,0 , 16,   0,   0,   0},
	{0x72,0 , 32,   0,   0,   0},
	{0x73,0 , 64,   0,   0,   0},
	{0x77,64, 16,   0,   0,   0},
	{0x78,64,  0,   0,1024,   0},
	{0x79,64,  0,   0, 128,   0},
	{0x7a,64,  0,   0, 256,   0},
	{0x7b,64,  0,   0, 512,   0},
	{0x7c,64,  0,   0,1024,   0},
	{0x7d,64,  0,   0,2048,   0},
	{0x7e,64,  0,   0, 256,   0},
	{0x7f,64,  0,   0, 512,   0},
	{0x80,16,  0,   0, 128,   0},
	{0x81,32,  0,   0, 128,   0},
	{0x82,32,  0,   0, 256,   0},
	{0x83,32,  0,   0, 512,   0},
	{0x84,32,  0,   0,1024,   0},
	{0x85,32,  0,   0,2048,   0},
	{0x86,64,  0,   0, 512,   0},
	{0x87,32,  0,   0,1024,   0},
	{0x88,64,  0,   0,   0,2048},	// IA-64 Only
	{0x89,64,  0,   0,   0,4096},
	{0x8a,64,  0,   0,   0,8192},
	{0x8d,128, 0,   0,   0,4096},
	{0x8F,32, 16,   0,   0,   0},
                  
	{0xFF, 0,  0,   0,   0,   0}
	};
