/* opt_sse.hpp: test bench code for seti@home client Originator: Ben Herndon */
#pragma once

#include "opcodes_SSE.hpp"
#include "optimize.hpp"

extern f_sum_func               sse_f_sum;

// extern rms_dev_func sse_rms_deviation;
extern tableSum2_func           sse_tableSum2;
extern tableSum3_func           sse_tableSum3;
extern tableSum4_func           sse_tableSum4;
extern tableSum5_func           sse_tableSum5;

extern GetPowerSpectrum_func    sse_v_GetPowerSpectrum;
extern GetPowerSpectrum_func	sse_GetTPS_sc8;

extern PwrSpectrumOnly_func 	sse_GetPSO_sc16_npr;
extern PwrSpectrumOnly_func 	sse_GetPSO_sc16_p32;
extern PwrSpectrumOnly_func 	sse_GetPSO_sc16_p64;
extern PwrSpectrumOnly_func 	sse_GetPSO_sc16_p128;

extern TransposeStrip_func		sse_vTranspose4ntw;
extern TransposeStrip_func		sse_vpfTranspose8x4ntw;

extern f_GetPeak_func           sse_f_GetPeak;


extern __m128 sse_nums[];
extern unsigned int sse_partMask[][4];

#ifndef ZERO
#define ZERO		sse_nums[0]
#define ONE         sse_nums[1]
#define TWO         sse_nums[2]
// polynomial coefficients for sine / cosine approximation in the chirp routine
#define SS1 sse_nums[4]
#define SS2 sse_nums[5]
#define SS3 sse_nums[6]
#define SS4 sse_nums[7]
#define CC1 sse_nums[8]
#define CC2 sse_nums[9]
#define CC3 sse_nums[10]
#endif

// 2^(52) = 4.503599627370496E15
// 2^(63) = 9.223372036854776E18
// 2^(64) = 1.8446744073709552E19
#define TWO_TO_52	4.503599627370496e15
const long double TWO_TO_63	= 9.223372036854776E18L;
const long double TWO_TO_64 = 1.8446744073709552E19L;
#define FPUROUND 6755399441055744.0 * 2048.0

extern int sse_inums[][4];

#define NEG_R (*(VEC *)&sse_inums[0])
#define NEG_I (*(VEC *)&sse_inums[1])
#define NEG_NO (*(VEC *)&sse_inums[2])

typedef __m128	vFloat;	// AK's name for SIMD
